Browse Source

Basic implementation of 'make headers_check'

Based on the 'headers_install' target, this performs a basic sanity check
on the exported headers -- so far only checking that they do not include
any other headers which aren't selected for import, but easily extendable.

Signed-off-by: David Woodhouse <dwmw2@infradead.org>
David Woodhouse 19 năm trước cách đây
mục cha
commit
684753599a
3 tập tin đã thay đổi với 23 bổ sung0 xóa
  1. 4 0
      Makefile
  2. 11 0
      scripts/Makefile.headersinst
  3. 8 0
      scripts/hdrcheck.sh

+ 4 - 0
Makefile

@@ -866,6 +866,10 @@ headers_install: include/linux/version.h
 	$(Q)rm -rf $(INSTALL_HDR_PATH)/include
 	$(Q)rm -rf $(INSTALL_HDR_PATH)/include
 	$(Q)$(MAKE) -rR -f $(srctree)/scripts/Makefile.headersinst obj=include
 	$(Q)$(MAKE) -rR -f $(srctree)/scripts/Makefile.headersinst obj=include
 
 
+PHONY += headers_check
+headers_check: headers_install
+	$(Q)$(MAKE) -rR -f $(srctree)/scripts/Makefile.headersinst obj=include HDRCHECK=1
+
 # ---------------------------------------------------------------------------
 # ---------------------------------------------------------------------------
 # Modules
 # Modules
 
 

+ 11 - 0
scripts/Makefile.headersinst

@@ -78,6 +78,11 @@ quiet_cmd_unifdef	  = UNIFDEF $(_dst)/$@
       cmd_unifdef	  = $(UNIFDEF) $(srctree)/$(obj)/$@ | $(HDRSED)	\
       cmd_unifdef	  = $(UNIFDEF) $(srctree)/$(obj)/$@ | $(HDRSED)	\
                             > $(INSTALL_HDR_PATH)/$(_dst)/$@ || :
                             > $(INSTALL_HDR_PATH)/$(_dst)/$@ || :
 
 
+quiet_cmd_check		  = CHECK   $(_dst)/$@
+      cmd_check		  = $(srctree)/scripts/hdrcheck.sh		\
+                              $(INSTALL_HDR_PATH)/include		\
+			      $(INSTALL_HDR_PATH)/$(_dst)/$@
+
 quiet_cmd_mkdir		  = MKDIR   $@
 quiet_cmd_mkdir		  = MKDIR   $@
       cmd_mkdir		  = mkdir -p $(INSTALL_HDR_PATH)/$@
       cmd_mkdir		  = mkdir -p $(INSTALL_HDR_PATH)/$@
 
 
@@ -112,6 +117,11 @@ __headersinst: $(subdir-y) $(header-y) $(unifdef-y) $(altarch-y) $(objhdr-y)
 
 
 .PHONY: $(header-y) $(unifdef-y) $(subdir-y)
 .PHONY: $(header-y) $(unifdef-y) $(subdir-y)
 
 
+ifdef HDRCHECK
+# Rules for checking headers
+$(objhdr-y) $(header-y) $(unifdef-y):
+	$(call cmd,check)
+else
 # Rules for installing headers
 # Rules for installing headers
 
 
 $(objhdr-y) $(subdir-y) $(header-y) $(unifdef-y): $(_dst)
 $(objhdr-y) $(subdir-y) $(header-y) $(unifdef-y): $(_dst)
@@ -134,6 +144,7 @@ $(header-y):
 $(unifdef-y):
 $(unifdef-y):
 	$(call cmd,unifdef)
 	$(call cmd,unifdef)
 endif
 endif
+endif
 
 
 hdrinst := -rR -f $(srctree)/scripts/Makefile.headersinst obj
 hdrinst := -rR -f $(srctree)/scripts/Makefile.headersinst obj
 
 

+ 8 - 0
scripts/hdrcheck.sh

@@ -0,0 +1,8 @@
+#!/bin/sh
+
+for FILE in `grep '^#include <' $2 | cut -f2 -d\< | cut -f1 -d\> | egrep ^linux\|^asm` ; do
+    if [ ! -r $1/$FILE ]; then
+	echo $2 requires $FILE, which does not exist
+	exit 1
+    fi
+done